import java.io.*;

class Rucksack {
  // Exakte Lsung des 0/1-Rucksackproblems

  static int[] a = {3, 7, 4, 12, 8, 10, 9, 14, 10, 12};
  static int[] w = {3, 5, 2, 11, 4,  6, 2, 15, 12,  9};
  static int   n = a.length;
  static int[] x = new int[n];
  static int   grenzgewicht;
  static int   maxWert = 0;

  static void Ausgabe (int[] v, int g, int w) {
    for (int i = 0; i < v.length; i++)
      System.out.print(v[i]);
    System.out.println(" (" + g + ", " + w + ")");
    } // Ende gib aus

  static void sucheBestes (int stufe, int gewicht, 
                                      int wert) {
    if (stufe < n) {
      x[stufe] = 1;
      sucheBestes(stufe + 1, gewicht + x[stufe] * a[stufe],
                                wert + x[stufe] * w[stufe]);
      x[stufe] = 0;
      sucheBestes(stufe + 1, gewicht, wert);
      } // Ende if
    else if (gewicht <= grenzgewicht && wert > maxWert) {
      Ausgabe(x, gewicht, wert);
      maxWert = wert; 
      } // Ende else
    } // Ende sucheBestes

  static void main (String[] xy) throws IOException {

    InputStreamReader lies = new InputStreamReader(System.in);
    BufferedReader    eing = new BufferedReader(lies);
   
    System.out.print("\nGrenzgewicht g = ");
    grenzgewicht = Integer.parseInt(eing.readLine());
    
    System.out.println("Loesungen (Gewicht, Wert):\n");
    sucheBestes(0, 0, 0);
       
    } // Ende main

  } // Ende Rucksack