import java.awt.*;

import java.util.*;

public class Sicht1 extends Canvas implements Observer{

  private Population p;

  private IDatenGA basis;



  public Sicht1(Population population){

    p=population;

    basis = p.getGrunddaten();

    //codelaenge = p.getCodeLaenge();

    p.addObserver(this);

    setBackground(Color.yellow);

  }



  public void paint(Graphics g){

    Rectangle r = this.getBounds();

    g.setColor(Color.blue); 

    g.drawString("Wert = f(Nummer des Individuums)",40,20);



    int breite = r.width-12; int hoehe = r.height-4;

    int maxX = p.getPopulationsGroesse();

    int maxY = p.getCodeLaenge()*p.getCodeLaenge();

    double dx = (double) breite/ (double)maxX;

    double dy = (double)hoehe/(double)(maxY);

    double deltaY=maxY/10.0;

    int x = 0;  int y = 0;

    while (y <= maxY){

      g.drawString(Integer.toString(y),

                            0,hoehe-(int)(y*dy));

      //y+=p.getCodeLaenge();

      y += deltaY;

    }

    for ( int k=0 ;k<maxX  ; k++ ) {

      Individuum indi = p.getIndividuum(k);

      x = (int) (dx * k );

      y = (int) (dy * basis.fitnesswert(indi));

      g.fillOval(x+20,hoehe-y-4,4,4);

    }

    int best = basis.fitnesswert(p.bestes());

    int bestPos=hoehe-4-(int)(dy*best);

    g.setColor(Color.red);  

    g.drawLine(12, bestPos, breite+4, bestPos);

    g.drawString("Maximaler Wert = "+best,40,40);

  }



  public void update(Observable o, Object arg) {

    repaint();

  }// update









}



